%define major 5
%define minor 24
%define fix 1

%define shrpdir %{_libdir}/perl5/%{version}/aix-thread-multi-64all/CORE

Name: perl
Version: %{major}.%{minor}.%{fix}
Release: 5
License: Artistic-1.0-Perl
Summary: The Perl Programming Language
Url: https://www.perl.org/

Source0: http://www.cpan.org/src/5.0/perl-%{version}.tar.gz

Patch0: perl-pase.patch
Patch1: perl-libdir.patch
Patch2: perl-Cwd.patch
Patch3: perl-set-os-version.patch
Patch4: perl-linklibperl-flags.patch

%description
Perl 5 is a highly capable, feature-rich programming language with over 29 years
of development. Perl 5 runs on over 100 platforms from portables to mainframes
and is suitable for both rapid prototyping and large scale development projects.


%package devel
Summary: Perl development files
Requires: perl = %{version}-%{release}

%description devel
Files needed to build against perl


%prep
%setup -q

%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1


%build
sh Configure \
  -de \
  -DPASE \
  -Dcc=gcc \
  -Dprefix=%{_prefix} \
  -Dman1dir=%{_mandir}/man1 \
  -Dman3dir=%{_mandir}/man3 \
  -Dusethreads \
  -Duseshrplib \
  -Duselongdouble=n \
  -Doptimize='%{optflags}' \
  -Dlibc=/QOpenSys/usr/lib/libc.a \
  -Dlibpth='%{_libdir} /QOpenSys/usr/lib' \
  -Dldflags='-Wl,-blibpath:%{shrpdir}:%{_libdir}:/QOpenSys/usr/lib' \
  -Dcldflags='-Wl,-blibpath:%{shrpdir}:%{_libdir}:/QOpenSys/usr/lib' \
  -Dshrdpldflags='-Wl,-blibpath:%{_libdir}:/QOpenSys/usr/lib' \
%if 0
  # This seems to cause an unexpected path through the convoluted Configure
  # script as for some reason Configure throws away the hint-provided
  # lddlflags and resets it to what we pass here (plus -Wl,-b64), even though
  # *at some point* it had both these values and the hints-provided values.
  # I don't have time to continue tracking this and it's not that big of an
  # issue, so I'm leaving this comment for the future.
  -Dlddlflags='-Wl,blibpath:%{_libdir}:/QOpenSys/usr/lib' \
%endif
  # end

# A race condition causes libperl.a to fail to build because DynaLoader.o is
# not built yet, so force it to 1 build job.
%global _smp_ncpus_max 1
%make_build

%install
%make_install

# Make libperl.o in the libperl.a unlinkable
rm %{buildroot}/%{shrpdir}/libperl.a
strip -e %{buildroot}/%{shrpdir}/libperl.o
ar cr %{buildroot}/%{shrpdir}/libperl.a %{buildroot}/%{shrpdir}/libperl.o

# Convert libperl.o to svr4 format shared library
cp %{buildroot}/%{shrpdir}/perl.exp ./shr_64.imp
sed -i 's|#! ..|#! libperl.so.%{major}.%{minor}(shr_64.o)|' shr_64.imp
cp %{buildroot}/%{shrpdir}/libperl.o shr_64.o
ar crlo libperl.so.%{major}.%{minor} shr_64.imp shr_64.o
install -c libperl.so.%{major}.%{minor} %{buildroot}/%{_libdir}/
ln -sr %{buildroot}/%{_libdir}/libperl.so.%{major}.%{minor} %{buildroot}/%{_libdir}/libperl.so

%files
%defattr(-, qsys, *none)
%{_bindir}/c2ph
%{_bindir}/corelist
%{_bindir}/cpan
%{_bindir}/enc2xs
%{_bindir}/encguess
%{_bindir}/h2ph
%{_bindir}/h2xs
%{_bindir}/instmodsh
%{_bindir}/json_pp
%{_bindir}/libnetcfg
%{_bindir}/perl
%{_bindir}/perl5.24.1
%{_bindir}/perlbug
%{_bindir}/perldoc
%{_bindir}/perlivp
%{_bindir}/perlthanks
%{_bindir}/piconv
%{_bindir}/pl2pm
%{_bindir}/pod2html
%{_bindir}/pod2man
%{_bindir}/pod2text
%{_bindir}/pod2usage
%{_bindir}/podchecker
%{_bindir}/podselect
%{_bindir}/prove
%{_bindir}/pstruct
%{_bindir}/ptar
%{_bindir}/ptardiff
%{_bindir}/ptargrep
%{_bindir}/shasum
%{_bindir}/splain
%{_bindir}/xsubpp
%{_bindir}/zipdetails
%{_mandir}/*/*
%{_libdir}/libperl.so.%{major}.%{minor}
%{shrpdir}/libperl.a
%{_libdir}/perl5/%{version}/App/
%{_libdir}/perl5/%{version}/Archive/
%{_libdir}/perl5/%{version}/Attribute/
%{_libdir}/perl5/%{version}/B/
%{_libdir}/perl5/%{version}/CPAN/
%{_libdir}/perl5/%{version}/Carp/
%{_libdir}/perl5/%{version}/Class/
%{_libdir}/perl5/%{version}/Compress/
%{_libdir}/perl5/%{version}/Config/
%{_libdir}/perl5/%{version}/DBM_Filter/
%{_libdir}/perl5/%{version}/Devel/
%{_libdir}/perl5/%{version}/Digest/
%{_libdir}/perl5/%{version}/Encode/
%{_libdir}/perl5/%{version}/ExtUtils/
%{_libdir}/perl5/%{version}/File/
%{_libdir}/perl5/%{version}/Filter/
%{_libdir}/perl5/%{version}/Getopt/
%{_libdir}/perl5/%{version}/HTTP/
%{_libdir}/perl5/%{version}/I18N/
%{_libdir}/perl5/%{version}/IO/
%{_libdir}/perl5/%{version}/IPC/
%{_libdir}/perl5/%{version}/JSON/
%{_libdir}/perl5/%{version}/Locale/
%{_libdir}/perl5/%{version}/Math/
%{_libdir}/perl5/%{version}/Memoize/
%{_libdir}/perl5/%{version}/Module/
%{_libdir}/perl5/%{version}/Net/
%{_libdir}/perl5/%{version}/Params/
%{_libdir}/perl5/%{version}/Parse/
%{_libdir}/perl5/%{version}/Perl/
%{_libdir}/perl5/%{version}/PerlIO/
%{_libdir}/perl5/%{version}/Pod/
%{_libdir}/perl5/%{version}/TAP/
%{_libdir}/perl5/%{version}/Term/
%{_libdir}/perl5/%{version}/Test/
%{_libdir}/perl5/%{version}/Text/
%{_libdir}/perl5/%{version}/Thread/
%{_libdir}/perl5/%{version}/Tie/
%{_libdir}/perl5/%{version}/Time/
%{_libdir}/perl5/%{version}/Unicode/
%{_libdir}/perl5/%{version}/User/
%{_libdir}/perl5/%{version}/autodie/
%{_libdir}/perl5/%{version}/encoding/
%{_libdir}/perl5/%{version}/pod/
%{_libdir}/perl5/%{version}/unicore/
%{_libdir}/perl5/%{version}/version/
%{_libdir}/perl5/%{version}/warnings/
%{_libdir}/perl5/%{version}/Exporter/
%{_libdir}/perl5/%{version}/Search/
%{_libdir}/perl5/%{version}/overload/
%{_libdir}/perl5/%{version}/*.pod
%{_libdir}/perl5/%{version}/*.pm
%{_libdir}/perl5/%{version}/*.pl
%{_libdir}/perl5/%{version}/aix-thread-multi-64all/B/
%{_libdir}/perl5/%{version}/aix-thread-multi-64all/Compress/
%{_libdir}/perl5/%{version}/aix-thread-multi-64all/Data/
%{_libdir}/perl5/%{version}/aix-thread-multi-64all/Devel/
%{_libdir}/perl5/%{version}/aix-thread-multi-64all/Digest/
%{_libdir}/perl5/%{version}/aix-thread-multi-64all/Encode/
%{_libdir}/perl5/%{version}/aix-thread-multi-64all/File/
%{_libdir}/perl5/%{version}/aix-thread-multi-64all/Filter/
%{_libdir}/perl5/%{version}/aix-thread-multi-64all/Hash/
%{_libdir}/perl5/%{version}/aix-thread-multi-64all/I18N/
%{_libdir}/perl5/%{version}/aix-thread-multi-64all/IO/
%{_libdir}/perl5/%{version}/aix-thread-multi-64all/IPC/
%{_libdir}/perl5/%{version}/aix-thread-multi-64all/List/
%{_libdir}/perl5/%{version}/aix-thread-multi-64all/MIME/
%{_libdir}/perl5/%{version}/aix-thread-multi-64all/Math/
%{_libdir}/perl5/%{version}/aix-thread-multi-64all/PerlIO/
%{_libdir}/perl5/%{version}/aix-thread-multi-64all/Scalar/
%{_libdir}/perl5/%{version}/aix-thread-multi-64all/Sub/
%{_libdir}/perl5/%{version}/aix-thread-multi-64all/Sys/
%{_libdir}/perl5/%{version}/aix-thread-multi-64all/Tie/
%{_libdir}/perl5/%{version}/aix-thread-multi-64all/Time/
%{_libdir}/perl5/%{version}/aix-thread-multi-64all/Unicode/
%{_libdir}/perl5/%{version}/aix-thread-multi-64all/auto/
%{_libdir}/perl5/%{version}/aix-thread-multi-64all/threads/
%{_libdir}/perl5/%{version}/aix-thread-multi-64all/*.pod
%{_libdir}/perl5/%{version}/aix-thread-multi-64all/*.pl
%{_libdir}/perl5/%{version}/aix-thread-multi-64all/*.pm
%{_libdir}/perl5/%{version}/aix-thread-multi-64all/.packlist

%files devel
%defattr(-, qsys, *none)
%{_libdir}/libperl.so
%{shrpdir}/
%exclude %{shrpdir}/libperl.a

%changelog
* Wed Mar 17 2021 Vasili Skurydzin <vasili.skurydzin@ibm.com> - 5.24.1
- Generate svr4 shared objects to link with libperl

* Thu Mar 11 2021 Kevin Adler <kadler@us.ibm.com> - 5.24.1
- Set proper path to libperl.a in libpath set by Configure

* Mon Feb 01 2021 Naveen Ram  <naveen.ram@ibm.com> - 5.24.1
- Fix perl cwd function in chroot by adding proper paths to pwd

* Wed Nov 06 2019 Kevin Adler <kadler@us.ibm.com> - 5.24.1
- Use SPDX license identifier
- Fix build by passing *ldflags to Configure instead of using regex after
- Use default optimization flags
- Package man pages

* Sat Mar 03 2018 - Kevin Adler <kadler@us.ibm.com>
- use perl -pie instead of GNU sed -i

* Wed Dec 20 2017 - Kevin Adler <kadler@us.ibm.com>
- Work around Perl LDFLAGS getting lost

* Wed Dec 20 2017 - Kevin Adler <kadler@us.ibm.com>
- Remove 64-bit GCC script workarounds for OBJECT_MODE

* Tue Nov 21 2017 - Kevin Adler <kadler@us.ibm.com>
- Fix perl build

* Tue Nov 21 2017 - Kevin Adler <kadler@us.ibm.com>
- Remove outdated TODO comments

* Tue Nov 21 2017 - Kevin Adler <kadler@us.ibm.com>
- Use auto dependency resolution instead of requiring pase-libs
